%% This is a brief intro to ideas in matlab related to homework 1

% This is a comment

% changing directory
cd ..
cd dice

% Listing the current directory
pwd

% editing a file
edit tutorial.m

% Listing directory contents
ls

% doing some math
1+2

% preventing output
1+2;

% storing in a variable
x = 1+2
x = x + 3

% more complex math
y = sqrt( exp(pi * 1i) )^2

% Logical math
x = ( (1 == 2) || (1 < 2) ) && ((1 ~= 2) || not(1 ~= 2))

% What about long lines?
x = ( (1 == 2) || (1 < 2) ) && ...
    ((1 ~= 2) || not(1 ~= 2))

% getting help
help sqrt;
doc sqrt;

%% Matrices

% A simple row
arow = [1, 2, 3, 4, 5]
arow = [1 2 3 4 5]

% A column 
acol = [1; 2; 3; 4]

% A matrix
amat = zeros(3,4)
amat = ones(3,4)
amat = eye(10)
amat = [1, 2, 3; 4, 5, 6; 7, 8, 9]
amat = [[1, 2, 3; 4, 5, 6; 7, 8, 9], ones(3,2)]
amat = [[1, 2, 3; 4, 5, 6; 7, 8, 9]; ones(4,3)]

% Getting an element from the matrix
amat = [1, 2, 3; 4, 5, 6; 7, 8, 9]
amat(2,3)
amat(3,2)

% Getting a submatrix from a matrix
amat([1,2], 1)
amat([1,2], [1,3])

% The colon operator
arow = 1:5
arow = 2.3:.5:5.7


% Getting a column from a matrix
amat(1:3, 1)
amat(1:end, 1)
amat(:, 1)

% Getting a row from a matrix
amat(1, 1:3)
amat(1, 1:end)
amat(1, :)


% Getting a submatrix from a matrix
amat(1:2, 2:3)

% Linearizing a matrix (stacking the columns)
amat(:)

% Indexing with logical value
amat( mod(amat(:,1),2) == 1, :)
amat(mod(amat,2) == 0)

%% Matrix operations
amat = reshape(1:12, 3,4)

% Transpose
amat'

% Addition
amat + amat

% subtraction
amat - amat

% multiplication
amat * amat'

% Inversion
inv(reshape(1:9, 3,3) + eye(3,3))

% point wise multiplication
amat .* amat

% pointwise division
amat ./ amat

% point wise exponentiation
amat .^ 2

%% Some statistics

amat = reshape(1:12, 3, 4)

% row sum
sum(amat)

% column sum
sum(amat,2)

% geting the max
max(amat)
max(amat, [], 2)


% Taking the mean
mean(amat)
mean(amat, 2)
mean( amat(:) )


%% Basic Plotting

% open a figure (not necessary)
figure(1)

% plot the line from 1 to 5
plot(sin(-3:.1:3))

% plotting something different
plot(-3:.1:3, sin(-3:.1:3), ...
    -3:.1:3, cos(-3:.1:3))

% labeling a plot
title('Fancy Name');
xlabel('xaxis');
ylabel('yaxis');

%% Generating a random set of number

% make a random [0,1] matrix;
data = rand(1,1000)

% Plot the histogram
hist(data, 20);

% make a different set of random numbers
mu = 2
sigma = 3
data = random('normal', mu, sigma, 1, 10000); 
hist(data, 50)

mean(data)
var(data)

% transforming a random variable
mu = 2
sigma = 3
data = sigma*randn(1, 10000) + mu;

hist(data, 50)

mean(data)
var(data)









